#PROGRESS BAR WITH TASKS
#-----------------------------------------------------------------------------
# 
# CHANGELOG
#
# 1.1 - 03.11.2012 * bug fixed
# 1.0 - 29.10.2012 * Initial release.
#		 
#
#-----------------------------------------------------------------------------
#
# Juantxo Pons
# www.skelion.net
#
# Progress bar based on thomthom worker.rb
#-----------------------------------------------------------------------------
class ProgressBar_tasks

def initialize(total, refresh_screen, ttask, taskname)  
	@ntask = 0 
	@ttask = ttask
	@taskname = taskname
	@total = total;
	if @total != nil then
	  @refresh_screen = refresh_screen#number of times view is refreshed
	  @index = 0
	  @each = @total/@refresh_screen
	  @count = 0
	  @time = Time.now
	end
  Sketchup.active_model.tools.push_tool(self)
  Sketchup.active_model.active_view.refresh 	
end 

def update()
	 @index+=1
	if @total <= @refresh_screen then
			Sketchup.active_model.active_view.refresh
	else
			if @index >= (@count*@each) then
				@count+=1
				Sketchup.active_model.active_view.refresh  	
			end		
	end	
end

def update_task(total, refresh_screen, taskname)
	@taskname = taskname
	@ntask+=1

@total = total;
	if @total != nil then 
		@refresh_screen = refresh_screen
		@index=0
		@each=@total/@refresh_screen
		@count=0 
		@time=Time.now
	end
 	if @ntask == @ttask then  Sketchup.active_model.tools.pop_tool end# END
	 Sketchup.active_model.active_view.refresh
end
  
    CLR_WINDOW      = Sketchup::Color.new(238,245,246)
    CLR_FRAME       = Sketchup::Color.new(140,145,146)
    CLR_TEXT        = Sketchup::Color.new(0,0,0)
    CLR_PROGRESSBAR = Sketchup::Color.new(151,152,157)
  
def draw(view)

    left  = Integer(view.vpwidth / 3)
    top   = Integer( (view.vpheight / 2) - 20 )
    width = Integer(view.vpwidth / 3)
    height = 40
    taskprogress = (@ntask/@ttask.to_f * width).to_i
	offset=70+height
	view.drawing_color = CLR_TEXT
		
#TASKS DRAW
	window2 = [
        [left-5,top-offset-10,0], [left+width+5,top-offset-10,0],
        [left+width+5,top-5,0], [left-5,top-5,0]
      ]
      frame2 = [
        [left,top-5-offset,0], [left+width,top-5-offset,0],
        [left+width,top-5-offset+height,0], [left,top-5-offset+height,0]
      ]
      fill2 = [
        [left,top-5-offset,0], [left+taskprogress,top-5-offset,0],
        [left+taskprogress,top-5-offset+height,0], [left,top-5-offset+height,0]
      ]
view.drawing_color = CLR_WINDOW
      view.draw2d( GL_QUADS, window2 )
      view.drawing_color = CLR_FRAME
      view.draw2d( GL_LINE_LOOP, window2 )
      
      view.drawing_color = CLR_PROGRESSBAR
      view.draw2d( GL_QUADS, fill2 )
      view.draw2d( GL_LINE_LOOP, frame2 )
	  
view.draw_text([left+5,top-5-70+10,0],"Executing task #{@ntask+1} of #{@ttask}\nTask #{@ntask+1}: #{@taskname}..." )
	  
#PROGRESS WINDOW
	if @total == nil || @total==0 then return end 
	ratio = @index / @total.to_f
	progress = Integer( ratio * width )
	percent = sprintf('%.2f', ratio * 100)
	
      window = [
        [left-5,top-5,0], [left+width+5,top-5,0],
        [left+width+5,top+height+70,0], [left-5,top+height+70,0]
      ]
      frame = [
        [left,top,0], [left+width,top,0],
        [left+width,top+height,0], [left,top+height,0]
      ]
      fill = [
        [left,top,0], [left+progress,top,0],
        [left+progress,top+height,0], [left,top+height,0]
      ]
	  
   
      view.line_width = 2
      view.line_stipple = ''
      
      view.drawing_color = CLR_WINDOW
      view.draw2d( GL_QUADS, window )
      view.drawing_color = CLR_FRAME
      view.draw2d( GL_LINE_LOOP, window )
      
      view.drawing_color = CLR_PROGRESSBAR
      view.draw2d( GL_QUADS, fill )
      view.draw2d( GL_LINE_LOOP, frame )
	    
            	  
	if @index == 0 then 
		  view.draw_text([left+5,top+height+10,0], "#0 of #{@total} (#{percent}%)\n" )
	else
		view.draw_text([left+5,top+height+10,0], "#{@index} of #{@total} (#{percent}%)\nEstimated #{estimated_time_left()} remaining\n")
	end
	  
end
  
    def estimated_time_left
		remaining=(@total-@index)*(Time.now-@time)/@index
		hours   = (remaining / 3600).to_i
		minutes = (remaining/60 - hours * 60).to_i
		seconds = (remaining - (minutes * 60 + hours * 3600)).to_i
		return "#{hours}h #{minutes}m #{seconds}s"
    end
  
end  # class ProgressBar_tasks  


############



############



#####EXAMPLE OF USE:

# t1=Time.now
# pb = ProgressBar_tasks.new(10000000,50,3,"for number 1")#(iterations of task, times refresed view, number of tasks, name of task)

# for i in 1..10000000
# 92459275924.0 / 983475023459082455.0
# pb.update()
# end

# pb.update_task(nil,50,"for number 2")#(iterations of task, times refresed view,  name of task)
# for i in 1..5000000
# 92459275924.0 / 983475023459082455.0
# end


# pb.update_task(2000000,50,"for number 3")
# for i in 1..2000000
# 92459275924.0 / 983475023459082455.0
# pb.update()
# end
# pb.update_task(nil,50,"end") #close the tool

# t2=Time.now
# p(t2-t1)#17.189

# (if exit command is used tool must be closed with command:  Sketchup.active_model.tools.pop_tool

#####################################################
##WITHOUT
# t1=Time.now
# for i in 1..10000000
# 92459275924.0 / 983475023459082455.0
# end

# for i in 1..5000000
# 92459275924.0 / 983475023459082455.0
# end


# for i in 1..2000000
# 92459275924.0 / 983475023459082455.0
# end
# t2=Time.now
# p(t2-t1)#4.459
#################################3
